
#ifndef CONDITION_H
#define CONDITION_H

#include <ctype.h>
#include "json2conlist.h"

class Condition
{
	public:
		Condition() {;}
		~Condition() {;}
	
	public:
		void init(conList* cList) {
			m_cList = cList;
			m_prefix = "";
		}
		
		void setPrefix(std::string prefix) {
			m_prefix = prefix;
		}
		
		bool find(std::string key, void* value) {
		    std::cerr << "key: " << m_prefix << key << std::endl;
			conIt it = m_cList->find(m_prefix+key);
			if (it == m_cList->end()) {
//				cerr << "not find !" << endl;
				return false;
			}
			
			std::string second = it->second;
			type t = check(second);
			switch (t) {
			case type_digit:
			case type_xdigit:
				char *e;
				*(unsigned int*)value = (unsigned int)strtoul(second.c_str(), &e, 0);
				break;
			default:	// type_string
				*(std::string *)value = second.c_str();
				break;
			}
			return true;
		}
	
	protected:
		void printInt(std::string name, unsigned int value) {
		  std::cout << name << ":" << value << std::endl;
		}
		
		void printString(std::string name, std::string value) {
		  std::cout << name << ":" << value << std::endl;
		}
	
	private:
		enum type {
			type_digit,
			type_xdigit,
			type_string
		};
		
		bool isDigit(std::string str) {
			for (int i = 0; i < (int)str.size(); ++i) {
				if (isdigit(str[i]) == false) {
					return false;
				}
			}
			return true;
		}
		
		bool isXdigit(std::string str) {
			if (str[0] != '0') {
				return false;
			}
			if (str[1] != 'x' && str[1] != 'X') {
				return false;
			}
			for (int i = 2; i < (int)str.size(); ++i) {
				if (isxdigit(str[i]) == false) {
					return false;
				}
			}
			return true;
		}
		
		type check(std::string str) {
			if (isDigit(str) == true) {
//				std::cout << "digit !" << std::endl;
				return type_digit;
			}
			if (isXdigit(str) == true) {
//				std::cout << "xdigit !" << std::endl;
				return type_xdigit;
			}
//			std::cout << "string !" << std::endl;
			return type_string;
		}
	
	private:
		conList* m_cList;
		std::string m_prefix;
};
#endif

