LIBRARY    = lib$(LIBNAME).a
LIBRARY_SO = lib$(LIBNAME).so

CC       = g++
# CC     = cc
CFLAGS   = -g -pipe -O2 -Wall
CPPFLAGS = $(addprefix -I, $(INC_DIRS))
ARFLAGS  = r
PIC_OPT  = -fPIC

# generate OBJS automatically.  Do not put spaces between ".cpp" and ".o"
OBJS   = $(subst .cpp,.o, $(SRCS))
SHOBJS = $(subst .cpp,.so, $(SRCS))

$(LIBRARY): $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

$(LIBRARY_SO): $(SHOBJS)
	$(CC) -shared -o $(LIBRARY_SO) $(SHOBJS)

.SUFFIXES: .so
.cpp.o:
	rm -f $@
	$(CC) $(CPPFLAGS) -c ${CFLAGS} -o $*.o $< 

.cpp.so:
	rm -f $@
	$(CC) $(CPPFLAGS) -c ${CFLAGS} $(PIC_OPT) -o $*.so $< 

clean:
	rm -f $(LIBRARY) $(OBJS) $(LIBRARY_SO) $(SHOBJS)

INSTALL_DIR = ../../lib

install:
	mkdir -p $(INSTALL_DIR)
	install -m 0644 $(TARGET) $(INSTALL_DIR)
